
/*  A Bison parser, made from /home/bruenen/PRIVAT/cvsgui/cvsgui/cvstree/parser.yy
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	INTEGER	257
#define	STRING	258
#define	TAG	259
#define	REVNUM	260
#define	ID_CHAR	261
#define	ID_DESCRIPTION	262
#define	ID_TOTREVISIONS	263
#define	ID_SELREVISIONS	264
#define	ID_KEYWORD	265
#define	ID_SYMBOLIC	266
#define	ID_ACCESS	267
#define	ID_LOCKS	268
#define	ID_STRICT	269
#define	ID_BRANCH	270
#define	ID_HEAD	271
#define	ID_WORKING	272
#define	ID_RCS	273
#define	ID_REVISION	274
#define	ID_DATE	275
#define	ID_BRANCHES	276
#define	ID_REVFOLLOW	277
#define	ID_ENDFOLLOW	278
#define	ID_LINES	279
#define	ID_ANYBUTSEP	280
#define	ID_LOCKEDBY	281
#define	ID_AUTHOR	282
#define	ID_STATE	283
#define	ID_COMMITID	284
#define	ID_KOPT	285

#line 1 "parser.yy"

/*
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 1, or (at your option)
** any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include "common.h"

#if qCvsDebug
#	define YYDEBUG 1
#else
#	define YYDEBUG 0
#endif

#ifdef __MWERKS__
	using namespace std;
#endif

static void expect(kTokens type);

static int sInt;
static CLogStr sStr;
static CRevNumber sRev;

static void printDebug(const char *tag, const char* value, bool setEndl)
{
#if YYDEBUG != 0
	if (yydebug) {
		printf("%s%s%s", tag, value, setEndl ? "\n" : "");
	}
#endif
}

static void printDebug(const char *tag, int value, bool setEndl)
{
#if YYDEBUG != 0
	if (yydebug) {
		printf("%s%d%s", tag, value, setEndl ? "\n" : "");
	}
#endif
}


#line 60 "parser.yy"
typedef union {
	char *string;
	int aint;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		138
#define	YYFLAG		-32768
#define	YYNTBASE	35

#define YYTRANSLATE(x) ((unsigned)(x) <= 285 ? yytranslate[x] : 102)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,    33,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    34,    32,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     6,     8,     9,    13,    15,    16,    20,
    21,    25,    26,    29,    31,    33,    35,    37,    39,    41,
    43,    45,    47,    49,    50,    53,    54,    56,    58,    59,
    63,    64,    67,    68,    70,    72,    76,    77,    79,    83,
    84,    85,    89,    90,    94,    95,    96,    97,    98,    99,
   100,   101,   119,   120,   124,   127,   128,   132,   133,   134,
   140,   141,   145,   146,   150,   151,   154,   155,   158,   160,
   162,   164,   165,   166,   172,   173,   174,   179,   180,   184,
   187,   188,   191,   192,   197,   200,   201,   204,   205,   209,
   211,   212,   216,   217,   222,   223,   226,   227,   232,   233,
   237,   238,   242,   243,   247,   248
};

static const short yyrhs[] = {    36,
     0,     0,    36,    37,     0,    41,     0,     0,    23,    38,
    49,     0,    24,     0,     0,     1,    39,    43,     0,     0,
    71,    40,    43,     0,     0,    41,    42,     0,   100,     0,
    98,     0,    96,     0,    94,     0,    88,     0,    84,     0,
    80,     0,    78,     0,    73,     0,    45,     0,     0,    43,
    44,     0,     0,     7,     0,     4,     0,     0,     8,    46,
    47,     0,     0,    47,    48,     0,     0,     7,     0,     4,
     0,    53,    50,    51,     0,     0,    55,     0,    50,    32,
    55,     0,     0,     0,    22,    52,    68,     0,     0,    20,
    54,     6,     0,     0,     0,     0,     0,     0,     0,     0,
    21,    56,    72,    33,    57,    72,    33,    58,    72,    59,
    72,    34,    60,    72,    34,    61,    72,     0,     0,    28,
    62,    70,     0,    27,    71,     0,     0,    29,    63,    70,
     0,     0,     0,    25,    64,    72,    65,    72,     0,     0,
    31,    66,    70,     0,     0,    30,    67,    70,     0,     0,
    68,    69,     0,     0,     6,    32,     0,     4,     0,     5,
     0,     3,     0,     0,     0,     9,    74,    72,    75,    76,
     0,     0,     0,    32,    10,    77,    72,     0,     0,    11,
    79,    70,     0,    12,    81,     0,     0,    81,    82,     0,
     0,    71,    34,    83,     6,     0,    13,    85,     0,     0,
    85,    86,     0,     0,    71,    87,    71,     0,    71,     0,
     0,    14,    89,    91,     0,     0,    14,    15,    90,    91,
     0,     0,    91,    92,     0,     0,    71,    34,    93,     6,
     0,     0,    16,    95,     6,     0,     0,    17,    97,     6,
     0,     0,    18,    99,    70,     0,     0,    19,   101,    70,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   100,   103,   105,   108,   110,   121,   121,   122,   132,   132,
   142,   144,   145,   148,   150,   151,   152,   153,   154,   155,
   156,   157,   158,   161,   163,   166,   168,   175,   184,   187,
   189,   191,   194,   196,   201,   208,   211,   212,   213,   216,
   217,   219,   221,   223,   234,   235,   236,   242,   248,   254,
   260,   266,   276,   277,   285,   293,   294,   302,   303,   311,
   319,   320,   328,   329,   338,   340,   343,   345,   356,   360,
   364,   368,   370,   377,   379,   381,   382,   390,   392,   400,
   404,   406,   409,   419,   429,   433,   435,   438,   448,   448,
   458,   466,   466,   473,   475,   477,   480,   490,   500,   502,
   512,   514,   524,   526,   535,   537
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","INTEGER",
"STRING","TAG","REVNUM","ID_CHAR","ID_DESCRIPTION","ID_TOTREVISIONS","ID_SELREVISIONS",
"ID_KEYWORD","ID_SYMBOLIC","ID_ACCESS","ID_LOCKS","ID_STRICT","ID_BRANCH","ID_HEAD",
"ID_WORKING","ID_RCS","ID_REVISION","ID_DATE","ID_BRANCHES","ID_REVFOLLOW","ID_ENDFOLLOW",
"ID_LINES","ID_ANYBUTSEP","ID_LOCKEDBY","ID_AUTHOR","ID_STATE","ID_COMMITID",
"ID_KOPT","';'","'/'","':'","cvslog","allDeclarations","allDeclaration","@1",
"@2","@3","rcsDeclarations","rcsDeclaration","anyDeclarations","anyDeclaration",
"descDeclaration","@4","descListDeclarations","descListDeclaration","allrevDeclarations",
"revOtherDeclarations","revBranches","@5","revRevision","@6","revOtherDeclaration",
"@7","@8","@9","@10","@11","@12","@13","@14","@15","@16","@17","@18","revnumListDeclarations",
"revnumListDeclaration","stringDeclaration","tagDeclaration","intDeclaration",
"totRevDeclaration","@19","@20","selRevDeclaration","@21","keyDeclaration","@22",
"symbolicNamesDeclaration","symbolicListDeclarations","symbolicListDeclaration",
"@23","accessDeclaration","accessListDeclarations","accessListDeclaration","@24",
"locksDeclaration","@25","@26","locksListDeclarations","locksListDeclaration",
"@27","branchRevDeclaration","@28","headRevDeclaration","@29","workingFileDeclaration",
"@30","rcsFileDeclaration","@31", NULL
};
#endif

static const short yyr1[] = {     0,
    35,    36,    36,    37,    38,    37,    37,    39,    37,    40,
    37,    41,    41,    42,    42,    42,    42,    42,    42,    42,
    42,    42,    42,    43,    43,    44,    44,    44,    46,    45,
    47,    47,    48,    48,    48,    49,    50,    50,    50,    51,
    52,    51,    54,    53,    55,    56,    57,    58,    59,    60,
    61,    55,    62,    55,    55,    63,    55,    64,    65,    55,
    66,    55,    67,    55,    68,    68,    69,    69,    70,    71,
    72,    74,    75,    73,    76,    77,    76,    79,    78,    80,
    81,    81,    83,    82,    84,    85,    85,    87,    86,    86,
    89,    88,    90,    88,    91,    91,    93,    92,    95,    94,
    97,    96,    99,    98,   101,   100
};

static const short yyr2[] = {     0,
     1,     0,     2,     1,     0,     3,     1,     0,     3,     0,
     3,     0,     2,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     0,     2,     0,     1,     1,     0,     3,
     0,     2,     0,     1,     1,     3,     0,     1,     3,     0,
     0,     3,     0,     3,     0,     0,     0,     0,     0,     0,
     0,    17,     0,     3,     2,     0,     3,     0,     0,     5,
     0,     3,     0,     3,     0,     2,     0,     2,     1,     1,
     1,     0,     0,     5,     0,     0,     4,     0,     3,     2,
     0,     2,     0,     4,     2,     0,     2,     0,     3,     1,
     0,     3,     0,     4,     0,     2,     0,     4,     0,     3,
     0,     3,     0,     3,     0,     3
};

static const short yydefact[] = {     2,
     0,     8,    70,     5,     7,     3,     4,    10,    24,     0,
    29,    72,    78,    81,    86,    91,    99,   101,   103,   105,
    13,    23,    22,    21,    20,    19,    18,    17,    16,    15,
    14,    24,     9,    43,     6,    37,    31,     0,     0,    80,
    85,    93,    95,     0,     0,     0,     0,    11,    28,    27,
    25,     0,    46,    58,     0,    53,    56,    63,    61,    40,
    38,    30,    71,    73,    69,    79,     0,    82,    90,    87,
    95,    92,   100,   102,   104,   106,    44,     0,     0,    55,
     0,     0,     0,     0,    41,    45,    36,    35,    34,    32,
    75,    83,     0,    94,     0,    96,     0,    59,    54,    57,
    64,    62,    65,    39,     0,    74,     0,    89,    97,    47,
     0,    42,    76,    84,     0,     0,    60,     0,    66,     0,
    98,     0,    68,    77,    48,     0,    49,     0,     0,    50,
     0,     0,    51,     0,    52,     0,     0,     0
};

static const short yydefgoto[] = {   136,
     1,     6,    10,     9,    32,     7,    21,    33,    51,    22,
    37,    62,    90,    35,    60,    87,   103,    36,    52,    61,
    78,   116,   126,   128,   131,   134,    81,    82,    79,   111,
    84,    83,   112,   119,    66,    95,    64,    23,    38,    91,
   106,   120,    24,    39,    25,    40,    68,   107,    26,    41,
    70,    93,    27,    43,    71,    72,    96,   115,    28,    44,
    29,    45,    30,    46,    31,    47
};

static const short yypact[] = {-32768,
     5,-32768,-32768,-32768,-32768,-32768,    49,-32768,-32768,   -19,
-32768,-32768,-32768,-32768,-32768,   -13,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    23,-32768,-32768,    48,-32768,     4,    16,     3,
     3,-32768,-32768,    20,    26,    16,    16,    23,-32768,-32768,
-32768,    29,-32768,-32768,     3,-32768,-32768,-32768,-32768,    -7,
-32768,    27,-32768,-32768,-32768,-32768,   -25,-32768,    28,-32768,
-32768,     3,-32768,-32768,-32768,-32768,-32768,     4,     4,-32768,
    16,    16,    16,    16,-32768,    48,-32768,-32768,-32768,-32768,
     6,-32768,     3,     3,     8,-32768,    10,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    34,-32768,    31,-32768,-32768,-32768,
     4,    44,-32768,-32768,    46,     4,-32768,    32,-32768,     4,
-32768,    22,-32768,-32768,-32768,     4,-32768,     4,    36,-32768,
     4,    37,-32768,     4,-32768,    72,    74,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    50,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    -6,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   -35,    -1,   -75,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    12,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768
};


#define	YYLAST		92


static const short yytable[] = {     8,
    34,    42,    97,    98,    -1,     2,    63,     3,    92,     3,
    75,    76,   -12,   -12,    85,   -12,   -12,   -12,   -12,    65,
   -12,   -12,   -12,   -12,    86,    73,    49,     4,     5,    50,
    88,    74,   -88,    89,    77,   117,   114,   105,    67,    69,
   122,   109,   110,   113,   124,    99,   100,   101,   102,   118,
   127,   121,   129,    80,   125,   132,    11,    12,   135,    13,
    14,    15,    16,   123,    17,    18,    19,    20,    53,   130,
   133,   137,    54,   138,    55,    56,    57,    58,    59,   104,
     0,    48,    94,     0,     0,     0,     0,     0,     0,     0,
     0,   108
};

static const short yycheck[] = {     1,
    20,    15,    78,    79,     0,     1,     3,     5,    34,     5,
    46,    47,     8,     9,    22,    11,    12,    13,    14,     4,
    16,    17,    18,    19,    32,     6,     4,    23,    24,     7,
     4,     6,     5,     7,     6,   111,     6,    32,    40,    41,
   116,    34,    33,    10,   120,    81,    82,    83,    84,     6,
   126,     6,   128,    55,    33,   131,     8,     9,   134,    11,
    12,    13,    14,    32,    16,    17,    18,    19,    21,    34,
    34,     0,    25,     0,    27,    28,    29,    30,    31,    86,
    -1,    32,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    93
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYPARSE_RETURN_TYPE
#define YYPARSE_RETURN_TYPE int
#endif


#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 222 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
YYPARSE_RETURN_TYPE
yyparse (void *);
#else
YYPARSE_RETURN_TYPE
yyparse (void);
#endif
#endif

YYPARSE_RETURN_TYPE
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
#ifndef YYSTACK_USE_ALLOCA
  int yyfree_stacks = 0;
#endif

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
#ifndef YYSTACK_USE_ALLOCA
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
#endif	    
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 5:
#line 110 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->AllRevs().push_back(CRevFile());
				gRevFile = &gRcsFile->LastRev();
			}

			expect (kRev);
		;
    break;}
case 7:
#line 121 "parser.yy"
{ gRcsFile = 0L; expect(kNone); ;
    break;}
case 8:
#line 122 "parser.yy"
{
										int c = yyvsp[0].aint;
										yyclearin;
										expect(kAnyButSep);
										if(gRevFile != 0L)
											gRevFile->DescLog() << (char)c;
										else if(gRcsFile != 0L)
											gRcsFile->DescLog() << (char)c;
									;
    break;}
case 10:
#line 132 "parser.yy"
{
										expect(kAnyButSep);
										if(gRevFile != 0L)
											gRevFile->DescLog() << sStr;
										else if(gRcsFile != 0L)
											gRcsFile->DescLog() << sStr;

										printDebug("Desp ", sStr.c_str(), true);
    ;
    break;}
case 27:
#line 168 "parser.yy"
{
							char c = yyvsp[0].aint;
							if(gRevFile != 0L)
								gRevFile->DescLog() << c;
							else if(gRcsFile != 0L)
								gRcsFile->DescLog() << c;
						;
    break;}
case 28:
#line 175 "parser.yy"
{
							if(gRevFile != 0L)
								gRevFile->DescLog() << yyvsp[0].string;
							else if(gRcsFile != 0L)
								gRcsFile->DescLog() << yyvsp[0].string;
							free(yyvsp[0].string);
						;
    break;}
case 29:
#line 185 "parser.yy"
{ expect(kAnyButSep); ;
    break;}
case 34:
#line 196 "parser.yy"
{
			char c = yyvsp[0].aint;
			if(gRcsFile != 0L)
				gRcsFile->DescLog() << c;
		;
    break;}
case 35:
#line 201 "parser.yy"
{
			if(gRcsFile != 0L)
				gRcsFile->DescLog() << yyvsp[0].string;
			free(yyvsp[0].string);
		;
    break;}
case 41:
#line 217 "parser.yy"
{ expect(kRevnum); ;
    break;}
case 43:
#line 222 "parser.yy"
{ expect(kRevnum); ;
    break;}
case 44:
#line 223 "parser.yy"
{
			if(gRevFile != 0L)
			{
				printDebug("\nRevNum ", sRev.c_str(), true);

				gRevFile->RevNum() = sRev;
			}
			sRev.reset();
		;
    break;}
case 46:
#line 235 "parser.yy"
{ expect(kDate); ;
    break;}
case 47:
#line 236 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_year = sInt - 1900;
			}
		;
    break;}
case 48:
#line 242 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_mon = sInt;
			}
		;
    break;}
case 49:
#line 248 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_mday = sInt;
			}
		;
    break;}
case 50:
#line 254 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_hour = sInt;
			}
		;
    break;}
case 51:
#line 260 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_min = sInt;
			}
		;
    break;}
case 52:
#line 266 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->RevTime().tm_sec = sInt;
			}

			expect(kNone);
			printDebug("Date ", asctime(&(gRevFile->RevTime())), false);
		;
    break;}
case 53:
#line 276 "parser.yy"
{ expect(kAuthorValue); ;
    break;}
case 54:
#line 277 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->Author() = sStr;
				printDebug("Author ", sStr.c_str(), true);
			}
		;
    break;}
case 55:
#line 286 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->Locker() = sStr;
				printDebug("Locker ", sStr.c_str(), true);
			}
		;
    break;}
case 56:
#line 293 "parser.yy"
{ expect(kStateOrTag); ;
    break;}
case 57:
#line 294 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->State() = sStr;
                printDebug("State ", sStr.c_str(), true);
			}
		;
    break;}
case 58:
#line 302 "parser.yy"
{ expect(kInt); ;
    break;}
case 59:
#line 303 "parser.yy"
{
			expect(kInt);
			if(gRevFile != 0L)
			{
				gRevFile->ChgPos() = sInt;
				printDebug("Lines +", sInt, false);
			}
		;
    break;}
case 60:
#line 311 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->ChgNeg() = sInt;
				printDebug(" ", sInt, true);
			}
		;
    break;}
case 61:
#line 319 "parser.yy"
{ expect(kKeyword); ;
    break;}
case 62:
#line 320 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->KeywordSubst() = sStr;
				printDebug("KeywordSubst ", sStr.c_str(), true);
			}			
		;
    break;}
case 63:
#line 328 "parser.yy"
{ expect(kID); ;
    break;}
case 64:
#line 329 "parser.yy"
{
		if(gRevFile != 0L)
			{
				gRevFile->CommitID() = sStr;
				printDebug("CommitID ", sStr.c_str(), true);
			}
		;
    break;}
case 68:
#line 345 "parser.yy"
{
			if(gRevFile != 0L)
			{
				gRevFile->BranchesList().push_back(sRev);
			}

			sRev.reset();
			expect(kRevnum);
		;
    break;}
case 69:
#line 357 "parser.yy"
{ sStr = yyvsp[0].string; free(yyvsp[0].string); ;
    break;}
case 70:
#line 361 "parser.yy"
{ sStr = yyvsp[0].string; free(yyvsp[0].string); ;
    break;}
case 71:
#line 365 "parser.yy"
{ sInt = yyvsp[0].aint; ;
    break;}
case 72:
#line 369 "parser.yy"
{ expect(kInt); ;
    break;}
case 73:
#line 370 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->TotRevisions() = sInt;
			}
		;
    break;}
case 76:
#line 381 "parser.yy"
{ expect(kInt); ;
    break;}
case 77:
#line 382 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->SelRevisions() = sInt;
			}
		;
    break;}
case 78:
#line 391 "parser.yy"
{ expect(kKeyword); ;
    break;}
case 79:
#line 392 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->KeywordSubst() = sStr;
			}
		;
    break;}
case 83:
#line 410 "parser.yy"
{
			expect(kRevnum);
			if(gRcsFile != 0L)
			{
				CRevNumber newRev;
				newRev.Tag() = sStr;
				gRcsFile->SymbolicList().push_back(newRev);
			}
		;
    break;}
case 84:
#line 419 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				sRev.Tag() = gRcsFile->LastSymbName().Tag();
				gRcsFile->LastSymbName() = sRev;
			}
			sRev.reset();
		;
    break;}
case 88:
#line 439 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				CLogStr newAccess;
				newAccess = sStr;
				gRcsFile->AccessList().push_back(newAccess);
			}
		;
    break;}
case 90:
#line 448 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				CLogStr newAccess;
				newAccess = sStr;
				gRcsFile->AccessList().push_back(newAccess);
			}
		;
    break;}
case 91:
#line 459 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->LockStrict() = false;
			}
		;
    break;}
case 93:
#line 466 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->LockStrict() = true;
			}
		;
    break;}
case 97:
#line 481 "parser.yy"
{
			expect(kRevnum);
			if(gRcsFile != 0L)
			{
				CRevNumber newRev;
				newRev.Tag() = sStr;
				gRcsFile->LocksList().push_back(newRev);
			}
		;
    break;}
case 98:
#line 490 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				sRev.Tag() = gRcsFile->LastLock().Tag();
				gRcsFile->LastLock() = sRev;
			}
			sRev.reset();
		;
    break;}
case 99:
#line 501 "parser.yy"
{ expect(kRevnumOrNil); ;
    break;}
case 100:
#line 502 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->BranchRev() = sRev;
				printDebug("Branch :", sRev.c_str(), true);
			}
			sRev.reset();
		;
    break;}
case 101:
#line 513 "parser.yy"
{ expect(kRevnum); ;
    break;}
case 102:
#line 514 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->HeadRev() = sRev;
				printDebug("Head :", sRev.c_str(), true);
			}
			sRev.reset();
		;
    break;}
case 103:
#line 525 "parser.yy"
{ expect(kString); ;
    break;}
case 104:
#line 526 "parser.yy"
{
			if(gRcsFile != 0L)
			{
				gRcsFile->WorkingFile() = sStr;
				printDebug("WorkingFile :", sStr, true);
			}
		;
    break;}
case 105:
#line 536 "parser.yy"
{ expect(kString); ;
    break;}
case 106:
#line 537 "parser.yy"
{
			// push a new rcs file
			gRcsFiles.push_back(CRcsFile());
			gRcsFile = &gRcsFiles[gRcsFiles.size() - 1];
			gRcsFile->RcsFile() = sStr;
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 554 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
#ifndef YYSTACK_USE_ALLOCA
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
#endif
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
#ifndef YYSTACK_USE_ALLOCA
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
#endif    
  return 1;
}
#line 544 "parser.yy"


void yyerror(const char * /*txt*/, ...)
{
	expect(kAnyButSep);
}

static void expect(kTokens type)
{
	expectToken = type;
}

void yylval_set(const char *txt)
{
	yylval.string = strdup(txt);
}

void yylval_set(int anint)
{
	yylval.aint = anint;
}

void yylval_set(const CRevNumber & rev)
{
	sRev = rev;
}

void yyreset(void)
{
	currentLineNumber = 1;
	sStr = "";
	sInt = 0;
	sRev.reset();
	gRcsFiles.erase(gRcsFiles.begin(), gRcsFiles.end());
	gRcsFile = 0L;
	gRevFile = 0L;
	expect(kNone);
}
